#!/usr/bin/env python
# -*- coding:utf-8 -*-

# Program: 客户下订单+kafka 订单推送
# Author : HH
# Date   : 2016-02-27

import sys
import mysql.connector
import time
import simplejson as json
from pykafka import KafkaClient  

reload(sys)
sys.setdefaultencoding('utf-8')

if __name__ == '__main__':
  '''
  获取队列数据保存到数据库
  '''
  # 设置公共库连接配置
  db_config_common = {
    'user'    : 'root',
    'password': 'root',
    'host'    : '127.0.0.1',
    'port'    : 3306,
    'database': 'test'
  }
  # 配置连接kafka
  client = KafkaClient(hosts="192.168.137.11:9092, \
                              192.168.137.11:9093, \
                              192.168.137.11:9094")
  topic = client.topics['shop']
  # 生成消费者
  balanced_consumer = topic.get_balanced_consumer(
    consumer_group='goods_group',
    auto_commit_enable=True,
    zookeeper_connect='localhost:2181'
  )
  # 获得公共数据库的链接和游标
  conn_common = mysql.connector.connect(**db_config_common)
  cursor_select_common = conn_common.cursor(buffered=True)
  
  # 消费信息
  for message in balanced_consumer:
    if message is not None:
      # 解析json为dict
      info_dict = json.loads(message.value)
      select_sql = '''
        SELECT s.user_id,
          ug.user_guide_id,
          u.table_flag,
          u.db_name,
          ss.value AS db_config_json
        FROM store AS s
          LEFT JOIN user AS u USING(user_id)
          LEFT JOIN user_guide AS ug USING(user_id)
          LEFT JOIN system_setting AS ss ON ss.name = u.db_name
        WHERE s.user_id = {user_id}
      '''.format(user_id=info_dict['user_id'])
      cursor_select_common.execute(select_sql)
      sell_user_id, user_guide_id, sell_table_flag, sell_dbname, \
      sell_db_config_json = cursor_select_common.fetchone()
      
      # 获得出售者的数据库链接描述符以及游标
      conn_sell = mysql.connector.connect(**json.loads(sell_db_config_json))
      cursor_dml_sell = conn_sell.cursor(buffered=True)
      if info_dict['option_type'] == 'insert':
        # 构造insert sql语句
        if info_dict['option_table'] == 'order_goods':
          insert_sql = '''
            INSERT INTO {table_name}_{flag} VALUES(
              {order_goods_id},
              {sell_order_id},
              {goods_id},
              {user_guide_id},
              {price},
              {num}
            )
          '''.format(table_name = info_dict['option_table'],
               flag = sell_table_flag,
               **info_dict['option_obj']
          )
        elif info_dict['option_table'] == 'sell_order':
          insert_sql = '''
            INSERT INTO {table_name}_{flag} VALUES(
              {sell_order_id},
              {user_guide_id},
              {user_id},
              {price},
              {status}
            )
          '''.format(table_name = info_dict['option_table'],
               flag = sell_table_flag,
               **info_dict['option_obj']
          )
        # 执行sql
        cursor_dml_sell.execute(insert_sql)
        conn_sell.commit()
        cursor_dml_sell.close()
        conn_sell.close()
      elif info_dict['option_type'] == 'update':
        pass
